%punti di interpolazione
X= [2010.5	2011.5	2012.5	2013	2013.5	2014]';
Y= [8	4.5	3.5	5	6.6	4]';
plot(X,Y,'ro')
hold on 
% punti di valutazione per gli approssimanti/interpolanti
z= linspace(min(X),max(X));

%-----------------------------------------------------------------------
% INTERPOLAZIONE
%-----------------------------------------------------------------------
% polinomio base di Newton
c = InterpN(X,Y);
pval1 = HornerN(c,X,z);

% spline cubiche
pval2 = spline(X,Y,z);

% polinomio base delle potenze
% grado 5
n=5;
V=[ones(6,1) X X.^2 X.^3 X.^4 X.^5];
cond(V)
c = V\Y;
c=c(n+1:-1:1);
pval3 = polyval(c,z);

% Disegna il grafico degli interpolanti
plot(z,pval1,'b-',z,pval2,'g-',z,pval3,'m-');
legend('Punti di interp.','Interpolante di Newton','Interpolante spline cubica','Interpolante base delle potenze');

% valutazione dell'interpolante nel punto x=2012;
x=2012
y = spline(X,Y,x)
plot(x,y,'*b')

pause

%-----------------------------------------------------------------------
% APPROSSIMAZIONE MINIMI QUADRATI
%-----------------------------------------------------------------------
figure
plot(X,Y,'ro')
hold on 

%1. Approssimazione mediante equazioni normali con un polinomio di grado 1
% a1=polyfit(X,Y,1);
% %Valutazione dell'approssimante di grado 1
% pval4=polyval(a1,z);

%2. Approssimazione mediante equazioni normali con un polinomio di grado 2
a2=polyfit(X,Y,2);
pval4=polyval(a2,z);

% % approssimazione ai minimi quadrati metodo LSQR grado 1
% H=[ones(6,1) X];
% c=H\Y;
% c=c(2:-1:1);
% pval6=polyval(c,z);

% approssimazione ai minimi quadrati metodo LSQR grado 2
H=[ones(6,1) X (X.^2)];
c=H\Y;
c=c(3:-1:1);
pval5=polyval(c,z);
%plot(z,yyy,'k');

%-----------------------------------------------------------------------
% Disegna il grafico degli approssimanti
plot(z,pval4,'b-',z,pval5,'r-');
legend('Punti di approx.','Approssimante quadratico EN', 'Approssimante quadratico LSQR');
% 
